%define debpatch_version	14

Summary:	An userspace crypto-filesystem
Name:		cfs
Version:	1.4.1
Release:	0.fdr.5.2
Epoch:		0
License:	BSD like
Group:		System Environment/Daemons
URL:		http://www.crypto.com/software
Source0:	http://www.crypto.com/software/%{name}-%{version}.tar.gz
Source1:	cfsd.init
Source2:	mcrypt
Source3:	cfs-INSTALL
Source4:	cfsd.sysconfig
Patch0:		http://ftp.debian.org/debian/pool/main/c/cfs/cfs_1.4.1-%{debpatch_version}.diff.gz
Patch1: 	cfs-blowfish.patch
Patch3:		cfs-root.patch
Patch4:		cfs-1.4.1-rpm.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root
Requires:	nfs-utils
Requires(post,preun):	/sbin/chkconfig
Requires(post):		%{__mkdir}

%description
CFS is an encrypting file system for Unix-like OSs. It uses NFS as its
interface, and so is reasonably portable.


%package utils
Summary:	Some (inofficial) utilities for cfs
Group:		Applications/System
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	openssh-askpass procmail

%description utils
CFS is an encrypting file system for Unix-like OSs. It uses NFS as its
interface, and so is reasonably portable.

This package *IS NOT* part of the official cfs project but contains
some userspace tools making it easier to use cfs. The INSTALL file of
the base-package tells how to use the these tools.


%prep
%setup -q
%patch0 -p1 -b .deb
rm -f debian/*.deb debian/*/*.deb
rm -f debian/patches/{cfs-8bit-filenames.patch,read-long.patch}

for i in debian/patches/*; do
	patch -f -p0 <$i;
done

%patch1 -p1 -b .blowfish
%patch3 -p1 -b .root
%patch4 -p1 -b .rpm

%{__cp} -a %{SOURCE3} INSTALL


%define makeflags	BINDIR=$D%{_bindir} ETCDIR=$D%{_sysconfdir}

%build
unset D
%{__make} %{makeflags} %{?_smp_mflags} CFLAGS_EXTRA="$RPM_OPT_FLAGS" cfs


%install
%{__rm} -rf $RPM_BUILD_ROOT

%{__install} -d $RPM_BUILD_ROOT{/.cfsfs,%{_bindir},%{_sbindir}} 	\
		$RPM_BUILD_ROOT%{_sysconfdir}/sysconfig			\
		$RPM_BUILD_ROOT%{_initrddir}				\
   	        $RPM_BUILD_ROOT%{_mandir}/man{1,8}/		      	\
		$RPM_BUILD_ROOT%{_libdir}/%{name}		      	\
		$RPM_BUILD_ROOT/mnt/crypt

D=$RPM_BUILD_ROOT
%{__make} %{makeflags} install_cfs
%{__mv}  $RPM_BUILD_ROOT%{_sysconfdir}/cfsd $RPM_BUILD_ROOT%{_sbindir}/

%{__install} -p -m755 %{SOURCE1} $RPM_BUILD_ROOT%{_initrddir}/cfsd
%{__install} -p -m755 %{SOURCE2} $RPM_BUILD_ROOT%{_libdir}/%{name}/
%{__install} -p -m644 %{SOURCE4} $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/cfsd
%{__ln_s} mcrypt                 $RPM_BUILD_ROOT%{_libdir}/%{name}/ucrypt

for i in 1 8; do
	%{__install} -m644 *.$i $RPM_BUILD_ROOT%{_mandir}/man$i/
done

find ${RPM_BUILD_ROOT} -name '*esm*' -print0 | xargs -0r rm -f


%clean
%{__rm} -rf $RPM_BUILD_ROOT


%post
/sbin/chkconfig --add cfsd
## See %%files-section below...
test -d /mnt/crypt || %{__mkdir} -m755 /mnt/crypt

%preun
if [ "$1" = "0" ]; then
	## Do not stop/restart the service here, because
	## mounted directories might be still in use.
	## The standard RH nfs-utils package skips this
	## step also.
	/sbin/chkconfig --del cfsd
fi


%files
%defattr(-,root,root)
%doc LEVELS README* VERSION INSTALL
%doc %{_mandir}/*/*
%config %{_initrddir}/*
%config(noreplace) %{_sysconfdir}/sysconfig/*
%{_bindir}/*
%{_sbindir}/*
%attr(0,root,root)/.cfsfs

## cfsd creates this directory with mode 0777 but allows write
## access through specific interfaces only. To prevent misuse of
## this mount-point, generate it with 0755 mode but ignore the
## permission when verifying the package.
## Mark it as %%ghost to prevent rpm from generating it; else cpio can
## fail when cfsd is running.
%ghost %verify(not mode) /mnt/crypt


%files utils
%defattr(-,root,root)
%{_libdir}/%{name}


%changelog
* Wed Jun 30 2004 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0:1.4.1-0.fdr.5
- updated to debian-patch version 14
- updated documentation (fstab entry) so that it works with FC2's
  mount also

* Tue Jul 15 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 0:1.4.1-0.fdr.3
- s!%%optflags!$RPM_OPT_FLAGS!
- require nfs-utils
- enhanced init-script to fail on unconfigured systems and to return
  LSB compliant exit-codes
- other changes in the init-script

* Tue May  6 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 0:1.4.1-0.fdr.2
- documented some questionable places in the spec-file
- applied recent fedora policies
- splitted files with special requirements into a 'utils' subpackage
- updated debian patch

* Wed Feb 26 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 1.4.1-3.fedora.1
- updated debian patch

* Fri Aug 16 2002 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 1.4.1-2
- Using debian-patch now
- added /etc/sysconfig/cfsd configuration file
- adapted other patches

* Thu Nov 29 2001 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 1.4.1-1
- Updated to 1.4.1
- Added patch from http://www.mit.edu:8008/bloom-picayune/cfs/236
- Fixed mcrypt script
- Removing lockfile in initscript on 'restart' command now

* Sat Sep 15 2001 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 1.4.0.beta2-6
- Prepared for rhcontrib
- Added mcrypt-script + INSTALL file
 
* Tue Sep 12 2000 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de>
- initial build

### Local Variables:
### compile-command: "cd .. && ./buildpkg cfs"
### End:
